'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.redisConn = redisConn;

var _ioredis = require('ioredis');

var _ioredis2 = _interopRequireDefault(_ioredis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function redisConn() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$port = _ref.port;
  var port = _ref$port === undefined ? 6379 : _ref$port;
  var _ref$host = _ref.host;
  var host = _ref$host === undefined ? '127.0.0.1' : _ref$host;
  var _ref$family = _ref.family;
  var family = _ref$family === undefined ? 4 : _ref$family;
  var _ref$db = _ref.db;
  var db = _ref$db === undefined ? 0 : _ref$db;

  var redis = new _ioredis2.default(_extends({
    port: port,
    host: host,
    family: family,
    db: db
  }, arguments));

  redis.on('connect', function () {
    console.log('redis has connected');
  });

  redis.on('error', function (err) {
    console.error(err);
    process.exit(1);
  });

  redis.on('close', function () {
    console.warn('redis has closed.');
    process.exit(1);
  });

  redis.on('reconnecting', function () {
    console.log('redis has reconnecting');
  });
  return redis;
};