"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mhgetall = mhgetall;
exports.mkeysexist = mkeysexist;
exports.mzcount = mzcount;
exports.mgetjson = mgetjson;

var _generalJsUtils = require("general-js-utils");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function mhgetall(redisConn, ids) {
  var _this = this;

  var _ref = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var _ref$showEmptyObject = _ref.showEmptyObject;
  var showEmptyObject = _ref$showEmptyObject === undefined ? false : _ref$showEmptyObject;

  return new Promise(function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(s, f) {
      var pipeline, i, list, result, _i;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (Array.isArray(ids)) {
                _context.next = 3;
                break;
              }

              f(new Error("ids must be array"));
              return _context.abrupt("return");

            case 3:
              if (!(ids.length === 0)) {
                _context.next = 6;
                break;
              }

              s([]);
              return _context.abrupt("return");

            case 6:
              pipeline = redisConn.pipeline();

              for (i = 0; i < ids.length; i++) {
                pipeline.hgetall(ids[i]);
              }
              _context.prev = 8;
              _context.next = 11;
              return pipeline.exec();

            case 11:
              list = _context.sent;
              _context.next = 17;
              break;

            case 14:
              _context.prev = 14;
              _context.t0 = _context["catch"](8);

              f(_context.t0);

            case 17:
              result = [];

              for (_i = 0; _i < list.length; _i++) {
                if (!list[_i][0]) {
                  if (showEmptyObject || !(0, _generalJsUtils.isObjectEmpty)(list[_i][1])) {
                    result.push(list[_i][1]);
                  }
                }
              }
              s(result);

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this, [[8, 14]]);
    }));

    return function (_x2, _x3) {
      return ref.apply(this, arguments);
    };
  }());
};

function mkeysexist(redisConn, keys) {
  var _this2 = this;

  return new Promise(function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(s, f) {
      var pipeline, i, list, result, _i2;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (Array.isArray(keys)) {
                _context2.next = 3;
                break;
              }

              f(new Error("ids must be array"));
              return _context2.abrupt("return");

            case 3:
              if (!(keys.length === 0)) {
                _context2.next = 6;
                break;
              }

              s([]);
              return _context2.abrupt("return");

            case 6:
              pipeline = redisConn.pipeline();

              for (i = 0; i < keys.length; i++) {
                pipeline.exists(keys[i]);
              }
              _context2.prev = 8;
              _context2.next = 11;
              return pipeline.exec();

            case 11:
              list = _context2.sent;
              _context2.next = 17;
              break;

            case 14:
              _context2.prev = 14;
              _context2.t0 = _context2["catch"](8);

              f(_context2.t0);

            case 17:
              result = [];

              for (_i2 = 0; _i2 < list.length; _i2++) {
                if (!list[_i2][0]) {
                  result.push(Boolean(list[_i2][1]));
                }
              }
              s(result);

            case 20:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, _this2, [[8, 14]]);
    }));

    return function (_x4, _x5) {
      return ref.apply(this, arguments);
    };
  }());
};
function mzcount(redisConn, ids) {
  var _this3 = this;

  var _ref2 = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var _ref2$min = _ref2.min;
  var min = _ref2$min === undefined ? 0 : _ref2$min;
  var _ref2$max = _ref2.max;
  var max = _ref2$max === undefined ? 99999999999 : _ref2$max;

  return new Promise(function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(s, f) {
      var pipeline, i, list, result, _i3;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (Array.isArray(ids)) {
                _context3.next = 3;
                break;
              }

              f(new Error("ids must be array"));
              return _context3.abrupt("return");

            case 3:
              if (!(ids.length === 0)) {
                _context3.next = 6;
                break;
              }

              s([]);
              return _context3.abrupt("return");

            case 6:
              pipeline = redisConn.pipeline();

              for (i = 0; i < ids.length; i++) {
                pipeline.zcount(ids[i], min, max);
              }
              _context3.prev = 8;
              _context3.next = 11;
              return pipeline.exec();

            case 11:
              list = _context3.sent;
              _context3.next = 17;
              break;

            case 14:
              _context3.prev = 14;
              _context3.t0 = _context3["catch"](8);

              f(_context3.t0);

            case 17:
              result = [];

              for (_i3 = 0; _i3 < list.length; _i3++) {
                if (!list[_i3][0]) {
                  result.push(list[_i3][1]);
                } else {
                  result.push(null);
                }
              }
              s(result);

            case 20:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, _this3, [[8, 14]]);
    }));

    return function (_x7, _x8) {
      return ref.apply(this, arguments);
    };
  }());
};
function mgetjson(redisConn, ids) {
  var _this4 = this;

  return new Promise(function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(s, f) {
      var list, result, i;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (Array.isArray(ids)) {
                _context4.next = 3;
                break;
              }

              f(new Error("ids must be array"));
              return _context4.abrupt("return");

            case 3:
              if (!(ids.length === 0)) {
                _context4.next = 6;
                break;
              }

              s([]);
              return _context4.abrupt("return");

            case 6:
              _context4.prev = 6;
              _context4.next = 9;
              return redisConn.mget.apply(redisConn, ids);

            case 9:
              list = _context4.sent;
              _context4.next = 15;
              break;

            case 12:
              _context4.prev = 12;
              _context4.t0 = _context4["catch"](6);

              f(_context4.t0);

            case 15:
              result = [];
              i = 0;

            case 17:
              if (!(i < list.length)) {
                _context4.next = 29;
                break;
              }

              _context4.prev = 18;

              result.push(JSON.parse(list[i]));
              _context4.next = 26;
              break;

            case 22:
              _context4.prev = 22;
              _context4.t1 = _context4["catch"](18);

              f(_context4.t1);
              return _context4.abrupt("return");

            case 26:
              i++;
              _context4.next = 17;
              break;

            case 29:
              s(result);

            case 30:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, _this4, [[6, 12], [18, 22]]);
    }));

    return function (_x9, _x10) {
      return ref.apply(this, arguments);
    };
  }());
}